package com.datacloudsec.utils;

import com.datacloudsec.exception.UEException;
import com.sun.mail.util.MailSSLSocketFactory;
import java.io.File;
import java.util.Date;
import java.util.Properties;
import javax.activation.DataHandler;
import javax.activation.FileDataSource;
import javax.mail.Authenticator;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.Message.RecipientType;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;
import javax.mail.internet.MimeUtility;

public class MailUtil {

   public static void sendMail(String smtpServer, int smtpPort, final String fromAddress, final String password, String[] toAddress, String[] ccFromAddress, String[] bccFromAddress, String subject, boolean isSsl, String text, String html, File[] attach) throws Exception {
      Properties props = new Properties();
      props.put("mail.smtp.host", smtpServer);
      props.put("mail.smtp.port", Integer.valueOf(smtpPort));
      props.put("mail.smtp.connectiontimeout", Integer.valueOf(10000));
      props.put("mail.smtp.timeout", Integer.valueOf(10000));
      props.put("mail.smtp.auth", "true");
      Session session = Session.getInstance(props, new Authenticator() {
         protected PasswordAuthentication getPasswordAuthentication() {
            return new PasswordAuthentication(fromAddress, password);
         }
      });
      if(isSsl) {
         MailSSLSocketFactory sendMailMessage = new MailSSLSocketFactory();
         sendMailMessage.setTrustAllHosts(true);
         props.put("mail.smtp.ssl.enable", "true");
         props.put("mail.smtp.ssl.socketFactory", sendMailMessage);
         props.put("mail.smtp.socketFactory.fallback", "false");
         props.put("mail.smtp.socketFactory.port", Integer.valueOf(smtpPort));
      }

      MimeMessage var24 = new MimeMessage(session);
      var24.setFrom(new InternetAddress(fromAddress));
      InternetAddress[] addres = new InternetAddress[toAddress.length];

      for(int multipart = 0; multipart < toAddress.length; ++multipart) {
         addres[multipart] = new InternetAddress(toAddress[multipart]);
      }

      var24.setRecipients(RecipientType.TO, addres);
      int e;
      InternetAddress[] var25;
      if(ccFromAddress != null && ccFromAddress.length > 0) {
         var25 = new InternetAddress[ccFromAddress.length];

         for(e = 0; e < ccFromAddress.length; ++e) {
            var25[e] = new InternetAddress(ccFromAddress[e]);
         }

         var24.setRecipients(RecipientType.CC, var25);
      }

      if(bccFromAddress != null && bccFromAddress.length > 0) {
         var25 = new InternetAddress[bccFromAddress.length];

         for(e = 0; e < bccFromAddress.length; ++e) {
            var25[e] = new InternetAddress(bccFromAddress[e]);
         }

         var24.setRecipients(RecipientType.BCC, var25);
      }

      var24.setSentDate(new Date());
      var24.setSubject(MimeUtility.encodeText(subject, "utf-8", "B"));
      MimeMultipart var26 = new MimeMultipart();
      var24.setContent(var26);
      if(text != null || html != null) {
         MimeBodyPart var27 = new MimeBodyPart();
         if(html != null) {
            var27.setContent(html, "text/html;charset=utf-8");
         } else if(text != null) {
            var27.setText(text);
         }

         var26.addBodyPart(var27);
      }

      if(attach != null && attach.length > 0) {
         File[] var20 = attach;
         int var19 = attach.length;

         for(int msg = 0; msg < var19; ++msg) {
            File var29 = var20[msg];
            MimeBodyPart mbpAttach = new MimeBodyPart();
            FileDataSource dataSource = new FileDataSource(var29);
            mbpAttach.setDataHandler(new DataHandler(dataSource));
            mbpAttach.setFileName(MimeUtility.encodeText(dataSource.getName()));
            var26.addBodyPart(mbpAttach);
         }
      }

      try {
         Transport.send(var24, var24.getAllRecipients());
      } catch (Exception var23) {
         String var28 = var23.getMessage();
         if(var28 != null) {
            if(var28.contains("password")) {
               throw new UEException("密码错误", var23);
            }

            if(var28.contains("554")) {
               throw new UEException("发送内容被邮件服务器阻止，请检查邮件中是否存在敏感词或广告", var23);
            }

            if(var28.contains("Unknown SMTP host")) {
               throw new UEException("发送服务器【SMTP】地址错误", var23);
            }

            if(var28.contains("535")) {
               throw new UEException("身份验证失败【email地址或密码错误】", var23);
            }

            if(var28.contains("454")) {
               throw new UEException("使用SSH端口错误，请检查邮件服务器配置", var23);
            }
         }

         throw var23;
      }
   }

   public static void main(String[] args) throws Exception {
      sendMail("smtp.qq.com", 465, "43047066@qq.com", "******", new String[]{"denghaozhong@datacloudsec.com"}, (String[])null, (String[])null, "安全扫描系统", true, "该系统非常好，是一款", (String)null, (File[])null);
   }
}
